#include <stdio.h>
#include <dos.h>
#include <conio.h>
#include "rs232.h"
#include "defines.h"

#ifdef __cplusplus
				#define __CPPARGS ...
#else
				#define __CPPARGS
#endif
int jj;
extern int repeatlock;
extern int COMPORT;
void OpenCom(int ComPort,
						int baud,
						int parity,
						int databits,
						int stopbits);
void CloseCom(int ComPort);
int xmitchar(int ComPort, int ch);
void Print(char * string);

/***************************** Async Interrupt routine   *********************/
void interrupt IRQ3_Interrupt(__CPPARGS)
{
		int baseid;
		int irq_id = 3;
		for (baseid = 0; baseid <= 7; baseid++)
		{
				if ((COM[baseid].int_id == irq_id) && COM[baseid].base_is_set)
				{
						int ComBase = COM[baseid].port_address;
						if (inportb(ComBase+IIR) == 0x04)
				{
	COM[baseid].ringbuf[COM[baseid].writptr] = inportb(ComBase + RBR);
	if (!repeatlock)
					outportb(ComBase+RBR, COM[baseid].ringbuf[COM[baseid].writptr]);
	COM[baseid].writptr = (COM[baseid].writptr + 1) & buff_size;
	COM[baseid].datardy = true;
						}
						if (irq_id > 7) outportb(PICCMD2, PICEOI);
						outportb(PICCMD1,PICEOI);
					}   /* test for matching interrupt and base is set     */
		}      /* loop through 8 COM ports and test for baseid    */
}        /* end of the interrupt at this point and return   */
void interrupt IRQ4_Interrupt(__CPPARGS)
{
		int baseid;
		int irq_id = 4;
		for (baseid = 0; baseid <= 7; baseid++)
		{
				if ((COM[baseid].int_id == irq_id) && COM[baseid].base_is_set)
				{
						int ComBase = COM[baseid].port_address;
						if (inportb(ComBase+IIR) == 0x04)
				{
	COM[baseid].ringbuf[COM[baseid].writptr] = inportb(ComBase + RBR);
	if (!repeatlock)
					outportb(ComBase+RBR, COM[baseid].ringbuf[COM[baseid].writptr]);
	COM[baseid].writptr = (COM[baseid].writptr + 1) & buff_size;
	COM[baseid].datardy = true;
						}
						if (irq_id > 7) outportb(PICCMD2, PICEOI);
						outportb(PICCMD1,PICEOI);
					}   /* test for matching interrupt and base is set     */
		}      /* loop through 8 COM ports and test for baseid    */
}        /* end of the interrupt at this point and return   */
void interrupt IRQ5_Interrupt(__CPPARGS)
{
		int baseid;
		int irq_id = 5;
		for (baseid = 0; baseid <= 7; baseid++)
		{
				if ((COM[baseid].int_id == irq_id) && COM[baseid].base_is_set)
				{
						int ComBase = COM[baseid].port_address;
						if (inportb(ComBase+IIR) == 0x04)
				{
	COM[baseid].ringbuf[COM[baseid].writptr] = inportb(ComBase + RBR);
	if (!repeatlock)
					outportb(ComBase+RBR, COM[baseid].ringbuf[COM[baseid].writptr]);
	COM[baseid].writptr = (COM[baseid].writptr + 1) & buff_size;
	COM[baseid].datardy = true;
						}
						if (irq_id > 7) outportb(PICCMD2, PICEOI);
						outportb(PICCMD1,PICEOI);
					}   /* test for matching interrupt and base is set     */
		}      /* loop through 8 COM ports and test for baseid    */
}        /* end of the interrupt at this point and return   */
void interrupt IRQ7_Interrupt(__CPPARGS)
{
		int baseid;
		int irq_id = 7;
		for (baseid = 0; baseid <= 7; baseid++)
		{
				if ((COM[baseid].int_id == irq_id) && COM[baseid].base_is_set)
				{
						int ComBase = COM[baseid].port_address;
						if (inportb(ComBase+IIR) == 0x04)
				{
	COM[baseid].ringbuf[COM[baseid].writptr] = inportb(ComBase + RBR);
	if (!repeatlock)
					outportb(ComBase+RBR, COM[baseid].ringbuf[COM[baseid].writptr]);
	COM[baseid].writptr = (COM[baseid].writptr + 1) & buff_size;
	COM[baseid].datardy = true;
						}
						if (irq_id > 7) outportb(PICCMD2, PICEOI);
						outportb(PICCMD1,PICEOI);
					}   /* test for matching interrupt and base is set     */
		}      /* loop through 8 COM ports and test for baseid    */
}        /* end of the interrupt at this point and return   */
void interrupt IRQ10_Interrupt(__CPPARGS)
{
		int baseid;
		int irq_id = 10;
		for (baseid = 0; baseid <= 7; baseid++)
		{
				if ((COM[baseid].int_id == irq_id) && COM[baseid].base_is_set)
				{
						int ComBase = COM[baseid].port_address;
						if (inportb(ComBase+IIR) == 0x04)
				{
	COM[baseid].ringbuf[COM[baseid].writptr] = inportb(ComBase + RBR);
	if (!repeatlock)
					outportb(ComBase+RBR, COM[baseid].ringbuf[COM[baseid].writptr]);
	COM[baseid].writptr = (COM[baseid].writptr + 1) & buff_size;
	COM[baseid].datardy = true;
						}
						if (irq_id > 7) outportb(PICCMD2, PICEOI);
						outportb(PICCMD1,PICEOI);
					}   /* test for matching interrupt and base is set     */
		}      /* loop through 8 COM ports and test for baseid    */
}        /* end of the interrupt at this point and return   */
void interrupt IRQ11_Interrupt(__CPPARGS)
{
		int baseid;
		int irq_id = 11;
		for (baseid = 0; baseid <= 7; baseid++)
		{
				if ((COM[baseid].int_id == irq_id) && COM[baseid].base_is_set)
				{
						int ComBase = COM[baseid].port_address;
						if (inportb(ComBase+IIR) == 0x04)
				{
	COM[baseid].ringbuf[COM[baseid].writptr] = inportb(ComBase + RBR);
	if (!repeatlock)
					outportb(ComBase+RBR, COM[baseid].ringbuf[COM[baseid].writptr]);
	COM[baseid].writptr = (COM[baseid].writptr + 1) & buff_size;
	COM[baseid].datardy = true;
						}
						if (irq_id > 7) outportb(PICCMD2, PICEOI);
						outportb(PICCMD1,PICEOI);
					}   /* test for matching interrupt and base is set     */
		}      /* loop through 8 COM ports and test for baseid    */
}        /* end of the interrupt at this point and return   */
void interrupt IRQ12_Interrupt(__CPPARGS)
{
		int baseid;
		int irq_id = 12;
		for (baseid = 0; baseid <= 7; baseid++)
		{
				if ((COM[baseid].int_id == irq_id) && COM[baseid].base_is_set)
				{
						int ComBase = COM[baseid].port_address;
						if (inportb(ComBase+IIR) == 0x04)
				{
	COM[baseid].ringbuf[COM[baseid].writptr] = inportb(ComBase + RBR);
	if (!repeatlock)
					outportb(ComBase+RBR, COM[baseid].ringbuf[COM[baseid].writptr]);
	COM[baseid].writptr = (COM[baseid].writptr + 1) & buff_size;
	COM[baseid].datardy = true;
						}
						if (irq_id > 7) outportb(PICCMD2, PICEOI);
						outportb(PICCMD1,PICEOI);
					}   /* test for matching interrupt and base is set     */
		}      /* loop through 8 COM ports and test for baseid    */
}        /* end of the interrupt at this point and return   */
void interrupt IRQ15_Interrupt(__CPPARGS)
{
		int baseid;
		int irq_id = 15;
		for (baseid = 0; baseid <= 7; baseid++)
		{
				if ((COM[baseid].int_id == irq_id) && COM[baseid].base_is_set)
				{
						int ComBase = COM[baseid].port_address;
						if (inportb(ComBase+IIR) == 0x04)
				{
	COM[baseid].ringbuf[COM[baseid].writptr] = inportb(ComBase + RBR);
	if (!repeatlock)
					outportb(ComBase+RBR, COM[baseid].ringbuf[COM[baseid].writptr]);
	COM[baseid].writptr = (COM[baseid].writptr + 1) & buff_size;
	COM[baseid].datardy = true;
						}
						if (irq_id > 7) outportb(PICCMD2, PICEOI);
						outportb(PICCMD1,PICEOI);
					}   /* test for matching interrupt and base is set     */
		}      /* loop through 8 COM ports and test for baseid    */
}        /* end of the interrupt at this point and return   */
/*************************************************************************/

/* Open the COM port     */
void OpenCom(int ComPort,
						int baud,
						int parity,
						int databits,
						int stopbits)
{
		int rate;
		int LCRreg;
		int interrupt_id;
		int interrupt_no;


		COM[ComPort].base_is_set = true;
		interrupt_no = COM[ComPort].int_id;
		interrupt_id = IRQ[interrupt_no].int_id;
		switch (ComPort)
		{
				case 0: Com1 = getvect(interrupt_id); break;
				case 1: Com2 = getvect(interrupt_id); break;
				case 2: Com3 = getvect(interrupt_id); break;
				case 3: Com4 = getvect(interrupt_id); break;
				case 4: Com5 = getvect(interrupt_id); break;
				case 5: Com6 = getvect(interrupt_id); break;
				case 6: Com7 = getvect(interrupt_id); break;
				case 7: Com8 = getvect(interrupt_id); break;
		}
		disable();
		switch (interrupt_no)
		{
				case  3: setvect(interrupt_id,IRQ3_Interrupt);  break;
				case  4: setvect(interrupt_id,IRQ4_Interrupt);  break;
				case  5: setvect(interrupt_id,IRQ5_Interrupt);  break;
				case  7: setvect(interrupt_id,IRQ7_Interrupt);  break;
				case 10: setvect(interrupt_id,IRQ10_Interrupt); break;
				case 11: setvect(interrupt_id,IRQ11_Interrupt); break;
				case 12: setvect(interrupt_id,IRQ12_Interrupt); break;
				case 15: setvect(interrupt_id,IRQ15_Interrupt); break;
    default: Print("\nInvalid Interrupt ID");
		}


		ComBase = COM[ComPort].port_address;
		outportb(IER+ComBase, 0x00);
		outportb(MCR+ComBase, 0x00);

		LCRreg = 0x80;
		LCRreg = LCRreg | parity;
		LCRreg = LCRreg | databits;
		LCRreg = LCRreg | stopbits;
		outportb(LCR+ComBase, LCRreg);
		rate = 115200L / baud;

		/* Load the two bytes of the register */
		outportb(DLM+ComBase, (char)((rate>>8)& 0xFF));      /* Hi byte */
		outportb(DLL+ComBase, (char)(rate     & 0xFF));      /* Low byte */

		outportb(LCR+ComBase, LCRreg & 0x7F);

		/* Enable Interrupts */
		IRQ[interrupt_no].old_PIC2_mask = inportb(PICMSK2);
		IRQ[interrupt_no].old_PIC1_mask = inportb(PICMSK1);
		outportb(PICMSK2, (IRQ[interrupt_no].old_PIC2_mask & IRQ[interrupt_no].PIC2_mask));
		outportb(PICMSK1, (IRQ[interrupt_no].old_PIC1_mask & IRQ[interrupt_no].PIC1_mask));
		enable();
		outportb(PICCMD2,PICEOI);
		outportb(PICCMD1,PICEOI);

		/* final flush to clear both interrupt controllers */
		outportb(IER+ComBase, 0x01);
		outportb(MCR+ComBase, 0x08);
//		Asynch_COM(COM[COMPORT].int_id);
		switch ( COM[COMPORT].int_id)
		{
		case 3:  IRQ3_Interrupt(); break;
		case 4:  IRQ4_Interrupt(); break;
		case 5:  IRQ5_Interrupt(); break;
		case 7:  IRQ7_Interrupt(); break;
		case 10: IRQ10_Interrupt(); break;
		case 11: IRQ11_Interrupt(); break;
		case 12: IRQ12_Interrupt(); break;
		case 15: IRQ15_Interrupt(); break;
  }
	}

		/*----------- Close any initialized COM -----------------------*/
void CloseCom(int ComPort)
{
		int interrupt_no, interrupt_id, ComBase;

		ComBase = COM[ComPort].port_address;
		COM[ComPort].base_is_set = false;
		interrupt_no = COM[ComPort].int_id;
		interrupt_id = IRQ[interrupt_no].int_id;
		outport(PICMSK2, (IRQ[interrupt_no].old_PIC2_mask));
		outport(PICMSK1, (IRQ[interrupt_no].old_PIC1_mask));
		switch (ComPort)
			{
						case 0: setvect(interrupt_id,Com1);  break;
						case 1: setvect(interrupt_id,Com2);  break;
						case 2: setvect(interrupt_id,Com3);  break;
						case 3: setvect(interrupt_id,Com4);  break;
						case 4: setvect(interrupt_id,Com5);  break;
						case 5: setvect(interrupt_id,Com6);  break;
						case 6: setvect(interrupt_id,Com7);  break;
						case 7: setvect(interrupt_id,Com8);  break;
			}
		outportb(IER+ComBase, 0x00);
		outportb(MCR+ComBase, 0x00);
}

/* Checks the datardy status for a given receive port and gets the char   */
/* It returns a -1 if there isn't anything, or the character if there is */
int  recvchar(int ComPort)
{
		int ch = -1;
		if (COM[ComPort].datardy)
		{
				ch = COM[ComPort].ringbuf[COM[ComPort].readptr];
				COM[ComPort].readptr = (COM[ComPort].readptr + 1) & buff_size;
				if (COM[ComPort].readptr == COM[ComPort].writptr)  COM[ComPort].datardy = false;
		}
		return(ch);
}

/* Transmits a character to the appropriate communications port   */
int xmitchar(int ComPort, int ch)
{

		int  LSRreg,i=-1;
		do {
						LSRreg = inportb(LSR+COM[ComPort].port_address) & 0x20;
						i++;
					}  while (LSRreg == 0);
		outportb(RBR+COM[ComPort].port_address,ch);
		return(i);
}

/* Returns a -1 if there is no DCD connect, a +1 if there is  */
int DCDconnect(int ComPort)
{
	int ComBase;
	int i = -1;
	ComBase = COM[ComPort].port_address;        /* Set ComBase Address   */
	if ((inportb(ComBase + MSR) & 0x80) == 0x80) i = 1;
	return (i);
}

int datardy(int comport)
{
return COM[comport].datardy;
}

/* Resets the input buffer on any given comport    */
void purgeline(int ComPort)
{

					COM[ComPort].readptr = 0;
					COM[ComPort].writptr = 0;
					COM[ComPort].datardy = false;
}


/* finis */
