
int num_interrupts = 0;

/* Define the communications port absolute numbers */
#define buff_size 0xFF

/* another global */
int ComBase;

/* Define the interrupt mask structure for every IRQ interrupt */
struct
{  unsigned int  port_address;
			unsigned char int_id;
			unsigned char base_is_set;
			unsigned char datardy;
			unsigned char ringbuf[buff_size+1];
			unsigned int  readptr;
			unsigned int  writptr;
} COM[8] = {
						{ 0x3F8,  4, 0, 0, 0, 0, 0 },   /* COM 1 */
						{ 0x2F8,  3, 0, 0, 0, 0, 0 },   /* COM 2 */
						{ 0x3E8, 10, 0, 0, 0, 0, 0 },   /* COM 3 */
						{ 0x3E0, 11, 0, 0, 0, 0, 0 },   /* COM 4 */
						{ 0x2F0, 12, 0, 0, 0, 0, 0 },   /* COM 5 */
						{ 0x2E8, 15, 0, 0, 0, 0, 0 },   /* COM 6 */
						{ 0x2E0,  0, 0, 0, 0, 0, 0 },   /* COM 7 */
						{ 0x260,  0, 0, 0, 0, 0, 0 }};  /* COM 8 */

/* Define the IRQ interrupt addresses and masks */
struct
{
		unsigned char int_id;
		unsigned char PIC1_mask;
		unsigned char PIC2_mask;
		unsigned char old_PIC1_mask;
		unsigned char old_PIC2_mask;
} IRQ[16] = {
							{ 0x08, 0xFE, 0xFF, 0, 0},   /* IRQ00 tick counter */
							{ 0x09, 0xFD, 0xFF, 0, 0},   /* IRQ01 Keyboard     */
							{ 0x0A, 0xFB, 0xFF, 0, 0},   /* IRQ02 PIC2         */
							{ 0x0B, 0xF7, 0xFF, 0, 0},   /* IRQ03 COM2         */
							{ 0x0C, 0xEF, 0xFF, 0, 0},   /* IRQ04 COM1         */
							{ 0x0D, 0xDF, 0xFF, 0, 0},   /* IRQ05 Mouse        */
							{ 0x0E, 0xBF, 0xFF, 0, 0},   /* IRQ06 Floppy Drive */
							{ 0x0F, 0x7F, 0xFF, 0, 0},   /* IRQ07 Printer      */
							{ 0x70, 0xFB, 0xFE, 0, 0},   /* IRQ08 Clock        */
							{ 0x71, 0xFB, 0xFD, 0, 0},   /* IRQ09 Redirect IRQ2*/
							{ 0x72, 0xFB, 0xFB, 0, 0},   /* IRQ10 COM3         */
							{ 0x73, 0xFB, 0xF7, 0, 0},   /* IRQ11 COM4         */
							{ 0x74, 0xFB, 0xEF, 0, 0},   /* IRQ12 COM5         */
							{ 0x75, 0xFB, 0xDF, 0, 0},   /* IRQ13 System Int   */
							{ 0x76, 0xFB, 0xBF, 0, 0},   /* IRQ14 Fixed Disk   */
							{ 0x77, 0xFB, 0x7F, 0, 0}};  /* IRQ15 COM6         */

/* Define address adders for the various Async card registers  */
#define RBR 0x00   /* Transmitter Holding Register        */
#define IER 0x01   /* Interrupt Enable Register           */
#define IIR 0x02   /* Interrupt Identification Register   */
#define LCR 0x03   /* Line Control Register               */
#define MCR 0x04   /* Modem Control Register              */
#define LSR 0x05   /* Line Status Register                */
#define MSR 0x06   /* Modem Status Register               */
#define DLL 0x00   /* Divisor Latch Least Significant     */
#define DLM 0x01   /* Divisor Latch Most  Significant     */

/* Define port addresses for the 8259 interrupt controller   */
#define PICCMD1 0x20  /* Primary Controller   */
#define PICMSK1 0x21
#define PICCMD2 0xA0  /* Secondary Controller */
#define PICMSK2 0xA1
#define PICEOI  0x20  /* End of interrupt     */

/* Define UART byte settings   */
#define pSpace 0x38
#define pOdd   0x08
#define pMark  0x28
#define pEven  0x18
#define pNone  0x00

/* Define UART number of data bits   */
#define d5 0x00
#define d6 0x01
#define d7 0x02
#define d8 0x03

/* define UART number of stop bits   */
#define s1 0x00
#define s2 0x04

#define true  1
#define false 0

#ifdef __cplusplus
				#define __CPPARGS ...
#else
				#define __CPPARGS
#endif
/* Store the pointers to the interrupt address  */
void interrupt (*Com1)(__CPPARGS);
void interrupt (*Com2)(__CPPARGS);
void interrupt (*Com3)(__CPPARGS);
void interrupt (*Com4)(__CPPARGS);
void interrupt (*Com5)(__CPPARGS);
void interrupt (*Com6)(__CPPARGS);
void interrupt (*Com7)(__CPPARGS);
void interrupt (*Com8)(__CPPARGS);
