/* -*-C-*-
********************************************************************************
*
* File:         wlytcpip.c
* Description:  TCP INET CLIENT to send lisp expressions to WINTERP lisp-server.
*               (this code derived from examples in HP manual 50952-9000
*               "ARPA Services/300 User's Guide" (pp 4-32 to 4-36)).

********************************************************************************
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <string.h>
#include <mem.h>
#include <sys/types.h>
#include <sys/winsock.h>
#include "tcpip.h" /* defines DEFAULT_INET_SERVICE_PORT, etc */
//#include "bm.h"
//#include "globals.h"
char temp[80];
int listen_s;   /* connected socket descriptor */
int new_s;          /* connected socket descriptor */
int global_status = -1;
char welcome[] = "\n**********Welcome to WA9XHN TCP/IP Listen Port**********\r\n\n";

#define MTU_MAX 1500    /* define maximum MTU message size */
void Print(char * string);

/*******************************************************************************
 * Send <message> to the server via socket <s>
 ******************************************************************************/
 int Character_Send(int Ch)
 {
  char temp[2];
  temp[0] = Ch;
  temp[1] - '\0';
  global_status = -1;
  if (new_s > 0)
     global_status = send(new_s, temp,1,0);
  return (global_status);
 }

 int Server_Send(int s,char *message)
{
 int status,i;

  if (strlen(message) > 0)
  {
    status =  send(s, message, strlen(message),0);
    if (status < 0)
    {
      sprintf(temp, "Unable to send(%i) [%s].\n", s,message);
      Print(temp);
      return (0);
    }
    else
     return status;
  }
  else
    Print("ya zapped me a null\n");
    return status;
}

/*******************************************************************************
 * Receive <message> from the server via socket <s>
 *******************************************************************************/
int Server_Receive(int s, char FAR *message, int maxsize)
{
int len = 0;
int flags = 0;
message[0] = 0;

  len = recv(s, message, maxsize, flags);
  message[len] = 0;
  return len;
}

int flush(int s)
{
  char message[255];
  return (recv(s, message, 255, 0));
}

/*******************************************************************************
 * Establish a connection with server process, returning socket descriptor
 * if successful.
*******************************************************************************/
int Client_Process(char *serverhost, u_short port)
{
  int s;   /* connected socket descriptor */
  struct hostent FAR  *hp;  /* pointer to host info for remote host */
  struct servent FAR  *sp;  /* service information pointer */
  struct sockaddr_in  peeraddr_in; /* for peer socket address */
  WORD wVersionRequested;
  WSADATA wsaData;

  wVersionRequested = 0x0101;

  WSAStartup(wVersionRequested, &wsaData);
  /* clear out address structures */
  memset((char *)&peeraddr_in, 0, sizeof(struct sockaddr_in));
  
  /* Set up the peer address to which we will connect. */
  peeraddr_in.sin_family = AF_INET;

  /* Get the host information for the hostname that the
 * user passed in. If serverhost==NULL, then make a quicker connection
 * by bypassing search in /etc/hosts and using loopback adrs directly.*/
  if (serverhost)
  {
    if ((hp = gethostbyname(serverhost)) == NULL) {
    sprintf(temp,"Unable to complete gethostbyname.\n",serverhost);
    Print(temp);
    WSACleanup();
    return -1;
  }
  peeraddr_in.sin_addr.s_addr = ((struct in_addr FAR *)(hp->h_addr))->s_addr;
  }
  else {   /* loopback */
    peeraddr_in.sin_addr.s_addr = inet_addr(DEFAULT_INET_SERVICE_HOSTADDR);
  }

  if (port == 0) {
    /* get port number for service "widget_interp" */
    if ((sp = getservbyname(DEFAULT_INET_SERVICE_NAME, "tcp")) == NULL) {
    sprintf(temp, "Unable to find \"%s\" in getservbyname.\n",
   DEFAULT_INET_SERVICE_NAME);
    Print(temp);
    WSACleanup();
    return -1;
  }
  peeraddr_in.sin_port = sp->s_port;
  }
  else
    peeraddr_in.sin_port = htons(port);

  /* Create the socket. */
  if ((s = socket(AF_INET, SOCK_STREAM, 0))== -1)
  {
    sprintf(stderr, "Unable to create Socket().\n");
    Print(temp);
    WSACleanup();
    return -1;
  }

  /* Try to connect to the remote server at the address
 * which was just built into peeraddr.  */
  if (connect(s, &peeraddr_in, sizeof(struct sockaddr_in)) == -1)
  {
    sprintf(temp, "Unable to connect(%i).\n", s);
    Print(temp);
    WSACleanup();
    return -1;
  }

  return(s);
}


/*******************************************************************************
 * Establish a server process
*******************************************************************************/
int Server_Process(u_short port)
{
  struct hostent FAR  *hp;  /* pointer to host info for remote host */
  struct sockaddr_in peeraddr_in; /* for peer socket address */
  char hostname[256];
  int iLength;
  WORD wVersionRequested;
  WSADATA wsaData;
  int status = 0;
  char temp[10];
  MSG Message;

  wVersionRequested = 0x0101;

  WSAStartup(wVersionRequested, &wsaData);
  /* clear out address structures */
  closesocket(1);
  closesocket(2);
  closesocket(3);
  closesocket(4);
  closesocket(5);

 if (gethostname(hostname, sizeof(hostname)))
 {
   Print("Unable to complete gethostname.\n");
   WSACleanup();
     exit(0);
  }

 if ((hp = gethostbyname(hostname)) == NULL)
 {
   fprintf(stderr,"Unable to complete gethostbyname[%i].\n",hp);
   WSACleanup();
   return -1;
 }

/* Open a socket. */
  if ((listen_s = socket(AF_INET, SOCK_STREAM, 0))== -1)
  {
    fprintf(stderr, "Unable to create Socket().\n");
    WSACleanup();
    return -1;
  }


  peeraddr_in.sin_port=htons(port);
  peeraddr_in.sin_family=AF_INET;
  peeraddr_in.sin_addr.s_addr = ((struct in_addr FAR *)(hp->h_addr))->s_addr;

  /* Bind to the socket  */
  if (bind(listen_s, &peeraddr_in, sizeof(peeraddr_in)) == -1)
  {
    fprintf(stderr, "Unable to bind(%i) Error is %i.\n", listen_s,WSAGetLastError());
    WSACleanup();
    return -1;
  }

  /* printf("Listening for call.\n");  */
  if (listen(listen_s,5) != 0)
  {
    fprintf(stderr, "Unable to invoke listen, Error = %i.\n",WSAGetLastError());
    WSACleanup();
    return -1;
  }

  iLength =  sizeof(struct sockaddr_in);
  status = 0;
  while (global_status == -1)
  {
   Print("Listening for call.\n");
   for (status=0;status<5000;status++);  //delay
   if ((new_s = accept(listen_s, &peeraddr_in, (int far *)&iLength)) == -1)
   {
     sprintf(temp, "Unable to accept(%i), Error = %i.\n",new_s, WSAGetLastError());
     Print(temp);
     WSACleanup();
     return 0;
   }
   if (new_s > 0)
   {
     sprintf(temp,"\n********** Call received on socket %i from [%s] **********\n",
     new_s, inet_ntoa(peeraddr_in.sin_addr));
     Print(temp);
     Server_Send(new_s,welcome);
     global_status = 0;
   /* now call MyMessageLoop routine  */
     while ( GetMessage(&Message, 0, 0, 0) && (global_status != -1))
     {
       TranslateMessage(&Message);
       DispatchMessage(&Message);
     }
     global_status = -1 ;   // Timing is critical
     closesocket(new_s);
     new_s = 0;
     Print("\n********** Connection Lost **********\n");
    }
   }
  return(0);
}


/******************************************************************************
 * Server_Disconnect -- shutdown the connection for further sends. This causes
 * the server to receive an EOF condition after it has received all data from
 * Server_Send().
******************************************************************************/
void Server_Disconnect(int s)
{
  WSACleanup();
  printf("Socket %i is WSACleanup'ed.\n",s);
}

/******************************************************************************
 *
 ******************************************************************************/
int open_client(char * hostname, u_short port)
{
  int hostname_given = 0; /* true if hostname was spec'd by user */
  int s;   /* connected socket desriptor */
  char* portstr;
  char* hoststr;

 if (strlen(hostname) > 4)
   hostname_given = 1;

 /* DEFAULT_INET_PORT_ENVVAR in "../src-server/config.h" */
  if (port == 0)
  {
    if ((portstr = (char *) getenv(DEFAULT_INET_PORT_ENVVAR)) != NULL)
      port = (u_short) atoi(portstr);
    else
      port = DEFAULT_INET_SERVICE_PORT; /* default port # for winterp server */
  }

  if (hostname_given) /* a remote connection w/ host spec'd on command line */
    s = Client_Process(hostname, port);
  else
  {    /* DEFAULT_INET_HOSTADDR_ENVVAR in "../src-server/config.h" */
    if ((hoststr = (char *) getenv(DEFAULT_INET_HOSTADDR_ENVVAR)) != NULL)
      s = Client_Process(hoststr, port); /* use hostname given in environ var */
    else
      s = Client_Process(NULL, port); /* a local connection -- use loopback */
  }

  return s;
}


int xgetinput(int s, char * message, int rsize)
{
 int size;
 int gsize;
 char * tempstr;
 char * p;

 tempstr = malloc(rsize + 1);
 gsize = rsize - 3;  /* greatest readin size */
 message[0] = 0;
 for (;;)
 {
  size = xygetinput(s,tempstr,rsize);
  strncat(message,tempstr,size);
  rsize = rsize - size;
  if ((p = strchr(message,'\r')) != NULL) break;
  if ((p = strchr(message,'\n')) != NULL) break;
 }
  p[0]   = '\r';
  p[1]   = '\n';
  p[2]   = '\0';
 free(tempstr);
 /* printf("[%s]\n",message);  */
 return rsize;
}

int xygetinput(int s,char * message, int rsize)
{
  struct timeval time;
  struct timeval *timeptr = &time;
  int MaxFD = 0;
  char * temp;
  fd_set set;
  int xset;
  int hit;
  int status = 0;
  int size = 0;
  int timeout = 0;


  /* allocate memory for string */
  if ((temp = (char *) malloc(300)) == NULL)
  {
   printf("Not enough memory to allocate buffer\n");
   exit(1);  /* terminate program if out of memory */
  }

  timeptr->tv_sec = 1;
  timeptr->tv_usec = 0;
  temp[0] = 0;

 while (status ==0)
 {

  FD_ZERO(&set);
  FD_SET(s,&set);
  MaxFD = max(MaxFD, s);

 /* wait for an incomming message */
  xset = select(MaxFD+1,&set,0,0,timeptr);
  /* printf("[%i]",xset);  */
  temp[0] = 0;
  message[0] = 0;
  switch (xset)
  {
  case -1:
   {
    printf("Error detected in select.\n");
    WSACleanup();
    exit(0);
   }
  case 0:        /* simple timeout, check keyboard */
   {
     timeout++;
     if (timeout > 600)
    {
     closesocket(s);
     free(temp);
     return (-1);
    }
     if (kbhit())
     {
     gets(temp);
     strcat(temp,"\r\n");
     Server_Send(s,temp);
     if (strstr(temp,"abort") == temp)
     {
     WSACleanup();
     exit(0);
      }
      else
      printf("Enter 'abort' for a graceful exit.\n");
    }
    break;
    }
  default:    /* got a real live one here, maybe */
   {
    size = Server_Receive(s,message,rsize);
    switch (size)
    {
      case 0: /* socket lost */
      {
      printf("Socket %i disconnected...\n",s);
      free(temp);
      return (-1);
      }
    case -1:
      break;  /* no data to receive, loop and try again */

    default:
     {
      if (size > 0)      /* got live data */
      {
      /* printf("[%i]%s",size,message); */
      timeout = 0;
      free(temp);
      return size;
      }
     }   /* default size */
     }  /* switch  size */
   }    /* default xset */
  }  /* switch xset  */
  } /* end while */
}

