/* modemst6.h   */
#define COM1 0
#define COM2 1
#define COM3 2
#define COM4 3
#define COM5 4
#define COM6 5
#define COM7 6
#define COM8 7



/* Define values for AMTOR and BAUDOT states */
#define BOTH 0	    /* case machine state */
#define NEITHER 99 /* initial case machine state */
#define UU 127	    /* untranslatable character */

/* ASCII characters */
#define UU 127	/* untranslatable character */
#define NUL 0
/*
#define LF 10
#define CR 13  */
#define BEL 7

/* DEFINE MODE */
enum mode {
     ascii,
					baudot,
					ita3,
					ccir476
};


/* define structure */
const struct  code
{
			int         baudot;  /* ita2 morray*/
			char        ita3;    /* si-arq */
			char        ccir476; /* sitor-A    */
};

/* Universal control characters */
struct code FIG    = { 27, 50, 75};
struct code LTR    = { 31, 56, 37};
struct code CR     = {  8, 97,  7};
struct code SP     = {  4, 11, 35};
struct code LF     = {  2, 13, 19};
struct code IDLE   = { UU,112, 21};
struct code IDLE_A = { UU, 26,102};
struct code IDLE_B = { UU, 74, 76};
struct code CS1    = { UU, UU, 26};
struct code CS2    = { UU, UU, 21};
struct code CS3    = { UU, UU, 38};
struct code CS4    = { UU, UU, 74};
struct code CS5    = { UU, UU, 22};

/* BAUDOT characters */
#define FIGS 27	  /* Baudot FIGS character and case machine state */
#define LTRS 31	  /* Baudot LTRS character and case machine state */
#define BCR 8     /* Baudot Carriage Return */
#define BSP 4     /* Baudot Space */
#define BLF 2     /* Baudot LineFeed */

/* AMTOR characters */
#define RQ          72  /* AMTOR   */
#define IDLE       112  /* AMTOR   */
#define IDLE_B      74  /* AMTOR   */
#define IDLE_A      26  /* AMTOR   */
#define ACR         97  /* AMTOR  carriage return*/
#define ALF         13  /* AMTOR  line feed */
#define ALTRS       56  /* AMTOR  letters state*/
#define AFIGS       50  /* AMTOR  figure state */
#define ASP         11  /* AMTOR  space */

/* Table of Baudot and AMTOR characters in ASCII order.*/
struct
{
			unsigned int state;
			char         baudot;  /* ita2 morray*/
			char         ita3;    /* si-arq */
			char         ccir476; /* sitor-A    */
}	table3[] = {
			{ BOTH, 0 , UU, UU},  /*0  NULL */
			{ BOTH, UU, UU, UU},  /*1  soh  */
			{ BOTH, UU, UU, UU},  /*2  stx  */
			{ BOTH, UU, UU, UU},  /*3  etx  */
			{ BOTH, UU, UU, UU},  /*4  eot  */
			{ BOTH, UU, UU, UU},  /*5  enq  */
			{ BOTH, UU, UU, UU},  /*6  ack  */
			{ FIGS, 5 , 37,104},  /*7  bell */
			{ BOTH, UU, UU, UU},  /*8  bs   */
			{ BOTH, UU, UU, UU},  /*9  ht   */
			{ BOTH, 2 , 97,  7},  /*10 LF   */
			{ BOTH, UU, UU, UU},  /*11 vt   */
			{ BOTH, UU, UU, UU},  /*12 ff   */
			{ BOTH, 8 , 13, 19},  /*13 CR   */
			{ BOTH, UU, UU, UU},  /*14 so */
			{ BOTH, UU, UU, UU},  /*15 si */
			{ BOTH, UU, UU, UU},  /*16 dle */
			{ BOTH, UU, UU, UU},  /*17 dc1 */
			{ BOTH, UU, UU, UU},  /*18 dc2 */
			{ BOTH, UU, UU, UU},  /*19 dc3 */
			{ BOTH, UU, UU, UU},  /*20 dc4 */
			{ BOTH, UU, UU, UU},  /*21 nak */
			{ BOTH, UU, UU, UU},  /*22 syn */
			{ BOTH, UU, UU, UU},  /*23 etb */
			{ BOTH, UU, UU, UU},  /*24 can */
			{ BOTH, UU, UU, UU},  /*25 em */
			{ BOTH, UU, UU, UU},  /*26 sub */
			{ BOTH, 27, 50, 73},  /*27 FIGS */
			{ BOTH, UU, UU, UU},  /*28 fs */
			{ BOTH, UU, UU, UU},  /*29 gs */
			{ BOTH, UU, UU, UU},  /*30 rs */
			{ BOTH, 31, 56, 37},  /*31 LTRS */
			{ BOTH,  4, 11, 35},  /*32 SPACE */
			{ FIGS, 13,100,100},  /*33  (exclamation) */
			{ FIGS, 17, 70, 28},  /*34 " */
			{ FIGS, 20, 37, 22},  /*35 # */
			{ FIGS,  9, 28, 44},  /*36  (dollar)    */
			{ BOTH, UU, UU, UU},  /*37  (percent)   */
			{ FIGS, 26, 67, 74},  /*38  (ampersand) */
			{ FIGS, 11, 98,104},  /*39  (sgl quote) */
			{ FIGS, 15,104, 97},  /*40 ( */
			{ FIGS, 18, 35, 26},  /*41 ) */
			{ BOTH, UU, UU, UU},  /*42 * (asterisk) */
			{ BOTH, UU, UU, UU},  /*43 + (plus)     */
			{ FIGS, 12, 21, 38},  /*44 , */
			{ FIGS, 3 , 44, 56},  /*45 - */
			{ FIGS, 28, 69, 70},  /*46 . */
			{ FIGS, 29, 52, 69},  /*47 / */
			{ FIGS, 22, 41, 82},  /*48 0 */
			{ FIGS, 23, 88, 56},  /*49 1 */
			{ FIGS, 19, 82, 13},  /*50 2 */
			{ FIGS, 1 , 14, 98},  /*51 3 */
			{ FIGS, 10, 19, 44},  /*52 4 */
			{ FIGS, 16, 81, 41},  /*53 5 */
			{ FIGS, 21, 84, 28},  /*54 6 */
			{ FIGS, 7 , 38, 74},  /*55 7 */
			{ FIGS, 6 ,  7, 22},  /*56 8 */
			{ FIGS, 24, 49, 50},  /*57 9 */
			{ FIGS, 14, 25, 98},  /*58 : */
			{ FIGS, 30, 73, 67},  /*59 ; */
			{ BOTH, UU, UU, UU},  /*60 (.LT.)  */
			{ BOTH, UU, UU, UU},  /*61 (equal) */
			{ BOTH, UU, UU, UU},  /*62 (.GT.)  */
			{ FIGS, 25, 76, 13},  /*63 ?       */
			{ BOTH, UU, UU, UU},  /*64 (at)    */
			{ LTRS, 3 , 44, 56},  /*65 A */
			{ LTRS, 25, 76, 13},  /*66 B */
			{ LTRS, 14, 25, 98},  /*67 C */
			{ LTRS, 9 , 28, 44},  /*68 D */
			{ LTRS, 1 , 14, 41},  /*69 E */
			{ LTRS, 13,100,100},  /*70 F */
			{ LTRS, 26, 67, 74},  /*70 G */
			{ LTRS, 20, 37, 22},  /*72 H */
			{ LTRS, 6 ,  7, 50},  /*73 I */
			{ LTRS, 11, 98,104},  /*74 J */
			{ LTRS, 15,104, 97},  /*75 K */
			{ LTRS, 18, 35, 26},  /*76 7L */
			{ LTRS, 28, 69, 70},  /*77 M */
			{ LTRS, 12, 21, 38},  /*78 N */
			{ LTRS, 24, 49, 14},  /*79 O */
			{ LTRS, 22, 41, 82},  /*80 P */
			{ LTRS, 23, 88, 81},  /*81 Q */
			{ LTRS, 10, 19, 42},  /*82 R */
			{ LTRS, 5 , 42, 52},  /*83 S */
			{ LTRS, 16, 81, 11},  /*84 T */
			{ LTRS, 7 , 38, 49},  /*85 U */
			{ LTRS, 30, 73, 67},  /*86 V */
			{ LTRS, 19, 82, 88},  /*87 W */
			{	LTRS, 29, 52, 69},  /*88 X */
			{	LTRS, 21, 84, 84},  /*89 Y */
			{ LTRS, 17, 70, 28},  /*90 Z */
			{	BOTH, UU, UU, UU},  /*91 [ (L bkt) */
			{ BOTH, UU, UU, UU},  /*92 \ (back sl) */
			{ BOTH, UU, UU, UU},  /*93 ] (R bkt) */
			{	BOTH, UU, UU, UU},  /*94 ^ (caret) */
			{ BOTH, UU, UU, UU}   /*95 _ (underscore) */
};

char state= 0;					/* assume initial LTRS state */
char last_state= NEITHER;			/* unspecified state */

	char * morsecode[] = {
		/* */  "3     ",  /* first offset = 32 space */
		/* */  "3     ",
		/* */  "3     ",
		/* */  "3     ",
		/* */  "3     ",
		/* */  "3     ",
		/* */  "3     ",
		/*'*/  "3     ",  
		/*(*/  "212212",
		/*)*/  "212212",
		/*ack*/"3     ",
		/*+*/  "3     ",
		/*,*/  "221122",
		/*-*/  "22122 ",
		/*.*/  "121212",
		/*/*/  "21121 ",
		/*0*/  "22222 ",
		/*1*/  "12222 ",
		/*2*/  "11222 ",
		/*3*/  "11122 ",
		/*4*/  "11112 ",
		/*5*/  "11111 ",
		/*6*/  "21111 ",
		/*7*/  "22111 ",
		/*8*/  "22211 ",
		/*9*/  "22221 ",
		/*:*/  "111222",
		/*;*/  "212121",
		/*<*/  "3     ",
		/*=*/  "3     ",
		/*>*/  "3     ",
		/*?*/  "112211",
		/*@*/  "3     ",
		/*A*/  "12    ",
		/*B*/  "2111  ",
		/*C*/  "2121  ",
		/*D*/  "211   ",
		/*E*/  "1     ",
		/*F*/  "1121  ",
		/*G*/  "221   ",
		/*H*/  "1111  ",
		/*I*/  "11    ",
		/*J*/  "1222  ",
		/*K*/  "212   ",
		/*L*/  "1211  ",
		/*M*/  "22    ",
		/*N*/  "21    ",
		/*O*/  "222   ",
		/*P*/  "1221  ",
		/*Q*/  "2212  ",
		/*R*/  "121   ",
		/*S*/  "111   ",
		/*T*/  "2     ",
		/*U*/  "112   ",
		/*V*/  "1112  ",
		/*W*/  "122   ",
		/*X*/  "2112  ",
		/*Y*/  "2122  ",
		/*Z*/  "2211  ",
		/* */  "3     ",
		/* */  "3     ",
		/* */  "3     ",
		/* */  "3     ",
		/* */  "3     ",
		/* */  "3     ",
		/* */  "3     ",
		/* */  "3     ",
		/* */  "3     ",
		/* */  "3     ",
		/* */  "3     ",
		/* */  "3     "
				};


/* finis */

